/*
 * ProcessFiller.h
 *
 *  Created on: 23.05.2009
 *      Author: breeze
 */

#ifndef PROCESSFILLER_H_
#define PROCESSFILLER_H_

#include <flysystemmonitor_export.h>

#include <QStringList>
#include <QVector>

#include <Process.h>

class QTranslator;
class QPluginLoader;
class ISystemMonitorPlugin;

namespace gtop_wrappers
{

class FLY_SYSTEM_MONITOR_EXPORT ProcessFiller
{
    ProcessFiller();
    ~ProcessFiller();
    void loadPlugins();
    void loadTranslates();
public:
    static ProcessFiller& instance();
    ProcessMap getProcesses( ProcessTypes _type = ALL );
    /// Добавляет параметр. Возвращает присвоенный ему index
    size_t  addParam( const QString& _name );
    /// Добавляет файл переводов
    void    addTranslate( const QString& _name );
    /// Количество полей у процессов
    size_t  size();
    QString name(size_t _idx);

protected:
    typedef QVector<QPluginLoader*> PluginLoaders;
    typedef QVector<ISystemMonitorPlugin*> PluginIntefaces;

    PluginLoaders m_pluginLoaders;
    PluginIntefaces m_pluginInterfaces;

    /// Хранит названия параметров
    QStringList m_Names;

    QList<QTranslator*> translators;
};

}

#endif /* PROCESSFILLER_H_ */
