#ifndef _COMMON_H_
#define _COMMON_H_

#include <flysystemmonitor_export.h>

#include <QString>
#include <QObject>

template<class T>
FLY_SYSTEM_MONITOR_EXPORT QString sizeToStr(const T& _value)
{
    double sz = _value, part;
    if( sz < 1024 )
        return QString::number(sz, 'f', 2) + QObject::tr(" B");

    part = sz / 1024;
    if( part < 1024 )
        return QString::number(part, 'f', 2) + QObject::tr(" KB");

    sz = part;
    part = sz / 1024;
    if( part < 1024 )
        return QString::number(part, 'f', 2) + QObject::tr(" MB");

    sz = part;
    part = sz / 1024;
    return QString::number(part, 'f', 2) + QObject::tr(" GB");
}

#endif // _TRACE_H_
